package com.uhf.event;

import android.os.SystemClock;

import com.uhf.uhfdemo.LeftFragment;
import com.uhf.uhfdemo.MyApp;
import com.uhf.util.MLog;


public class GetRFIDThread extends Thread {


    private GetRFIDThread() {
    }

    public static GetRFIDThread getInstance() {
        return MySingleton.instance;
    }

    static class MySingleton {
        static final GetRFIDThread instance = new GetRFIDThread();
    }

    private BackResult ba;

    private boolean ifPostMsg = false;

    public void setBackResult(BackResult ba) {
        this.ba = ba;
    }

    public boolean isIfPostMsg() {
        return ifPostMsg;
    }

    private boolean flag = true;

    public void destoryThread() {
        flag = false;
    }

    private long sTime;

    public void setIfPostMsg(boolean ifPostMsg) {
        if (ifPostMsg) {
            sTime = SystemClock.elapsedRealtime();
        }
        this.ifPostMsg = ifPostMsg;
    }

    // Whether in query tag mode
    private boolean searchTag; 

    public void setSearchTag(boolean searchTag) {
        this.searchTag = searchTag;
    }

    private boolean lockPostTag = false;

    public void setLockPostTag(boolean lockPostTag) {
        this.lockPostTag = lockPostTag;
    }
    public boolean getLockPostTag() {
        return lockPostTag;
    }

    @Override
    public void run() {
        long curTime, oldTime = 0;

        // Read rate per second
        long readRate = 0;

        // Start time
        long tempTime = 0; 
        while (flag) {
            if (ifPostMsg) {
                if (tempTime == 0 && sTime != 0) {
                    tempTime = sTime;
                }
                long cTime = SystemClock.elapsedRealtime();
                if (cTime - tempTime >= 1000 && tempTime != 0) {
//                    if (/*MyApp.getMyApp().getUhfMangerImpl().slrInventoryModelGet() == 3 ||*/ MyApp.getMyApp().getUhfMangerImpl().slrInventoryModelGet() == 4) {
//                        ba.postInventoryRate(LeftFragment.time);
//                        LeftFragment.time = 0;
//                        tempTime = cTime;
//                    }
//                    else {
                        ba.postInventoryRate(readRate);
                        readRate = 0;
                        tempTime = cTime;
//                    }
                }
                String[] tagData = MyApp.getMyApp().getUhfMangerImpl().readTagFromBuffer();
                MLog.e("epcFottest = " + tagData);
                if (tagData != null) {
                    readRate++;
                    oldTime = 0;
                    ba.postResult(tagData);
                } else if (searchTag) { 

                    // Clear status when no tag is queried for more than one second
                    curTime = System.currentTimeMillis();
                    if ((curTime - oldTime) > 2000 && (oldTime != 0)) {
                        ba.postResult(null);
                    }
                    if (oldTime == 0) {
                        oldTime = curTime;
                    }
                }
            }else if(lockPostTag) {
                String[] tagData = MyApp.getMyApp().getUhfMangerImpl().readTagFromBuffer();
                MLog.e("epcFottest = " + tagData);
                if (tagData != null) {
                    ba.postResult(tagData);
                }
            }else {
                if (readRate != 0 ) {

                    // Reset time
                    sTime =0;
                    tempTime =0;
                    readRate = 0;
                }
            }
        }
    }
}
