package com.uhf.setting;

import android.os.Bundle;
//import android.support.annotation.NonNull;
//import android.support.annotation.Nullable;
import android.util.Log;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.Spinner;

import com.uhf.base.UHFManager;
import com.uhf.base.UHFModuleType;
import com.uhf.event.BackResult;
import com.uhf.event.BaseFragment;
import com.uhf.event.GetRFIDThread;
import com.uhf.uhfdemo.MyApp;
import com.uhf.uhfdemo.R;
import com.uhf.util.LockDataAdapter;
import com.uhf.util.MLog;
import com.uhf.util.MUtil;
import com.uhf.util.MyListView;
import com.uhf.util.ThreadUtil;

import static android.text.TextUtils.isEmpty;

import static com.uhf.uhfdemo.MyApp.ifRMModule;
import static com.uhf.uhfdemo.MyApp.ifSupportR2000Fun;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

public class ReadOrWriteTagFragment extends BaseFragment implements View.OnClickListener, BackResult, AdapterView.OnItemClickListener {

    private Spinner spFilterMbWr, spMbWr;
    private EditText EtFilterAdsTagWr, EtFilterlenTagWr, EtFilterDataTagWr, EtAdsTagWr, EtLenTagWr, EtDataTagWr, EtPwdTagWr;
    private CheckBox CBFilterWr;
    private String[] spirw = {"RFU", "EPC", "TID", "USR"};
    Boolean threadAlive = true;
    private LockDataAdapter mListAdapter;
    private MyListView mListView;
    private Button BtRead,openLED;
    private View tops, bottoms;
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_write_tag, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        initView(view);
    }

    private void initView(View v) {

        tops = v.findViewById(R.id.wTop);
        bottoms = v.findViewById(R.id.wBottom);
        // Filter
        spFilterMbWr = tops.findViewById(R.id.spinner_MB);
        EtFilterAdsTagWr = tops.findViewById(R.id.Et_set_ads);
        EtFilterlenTagWr = tops.findViewById(R.id.Et_Set_len);
        EtFilterDataTagWr = tops.findViewById(R.id.Et_Set_data);

        spFilterMbWr.setSelection(0);
        CBFilterWr = v.findViewById(R.id.CB_FlWr);

        // Tag filtering, EPC start position (Bit)
        EtFilterAdsTagWr.setText("32");
        // Tag filtering, EPC length (Bit)
        EtFilterlenTagWr.setText("96");
        // Tag filtering, ECP data (hexadecimal)
        EtFilterDataTagWr.setText("1234567890ABCDEF12345678");


        // Reading and writing
        LinearLayout acs_pswd = bottoms.findViewById(R.id.acs_pswd);
        // Show the layout of the access password
        acs_pswd.setVisibility(View.VISIBLE);

        spMbWr = bottoms.findViewById(R.id.spinner_MB);
        ArrayAdapter<String> arradp_rw = new ArrayAdapter<String>(getActivity(),
                android.R.layout.simple_spinner_item, spirw);
        arradp_rw.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spMbWr.setAdapter(arradp_rw);

        // Set selected EPC
        spMbWr.setSelection(1);

        EtAdsTagWr = bottoms.findViewById(R.id.Et_set_ads);
        EtLenTagWr = bottoms.findViewById(R.id.Et_Set_len);
        EtPwdTagWr = bottoms.findViewById(R.id.Et_AcPwdRead);
        EtDataTagWr = bottoms.findViewById(R.id.Et_Set_data);

        v.findViewById(R.id.Bt_Wr).setOnClickListener(this);
        v.findViewById(R.id.Bt_Rd).setOnClickListener(this);

        // Reading and writing the EPC, Password (hexadecimal)
        EtPwdTagWr.setText("00000000");
        // Reading and writing the EPC, EPC start position (WORD type)
        EtAdsTagWr.setText("2");
        // Reading and writing the EPC, EPC length (WORD type)
        EtLenTagWr.setText("6");
        // Reading and writing the EPC, ECP data (hexadecimal)
        EtDataTagWr.setText("1234567890ABCDEF12345678");

        openLED = v.findViewById(R.id.bt_led);
        if (MyApp.getMyApp().getUhfMangerImpl().ifJ06() || !ifSupportR2000Fun || MyApp.if5100Module || UHFModuleType.SLR_MODULE == UHFManager.getType() || UHFModuleType.RM_MODULE == UHFManager.getType()) {
            openLED.setVisibility(View.GONE);
        }
        openLED.setOnClickListener(this);

        BtRead = v.findViewById(R.id.read_RFID);
        v.findViewById(R.id.read_RFID).setOnClickListener(this);
        v.findViewById(R.id.clear_Data).setOnClickListener(this);
        mListView = v.findViewById(R.id.specific_Msg);
        mListAdapter = new LockDataAdapter(getActivity(),realKeyList);
        mListView.setAdapter(mListAdapter);
        mListView.setOnItemClickListener(this);
        if(!MyApp.ifLockTagRead) {
            v.findViewById(R.id.read_epc).setVisibility(View.GONE);
        }else {
            v.findViewById(R.id.read_epc).setVisibility(View.VISIBLE);
        }
        GetRFIDThread.getInstance().setBackResult(this);
        dataMap.clear();
        realDataMap.clear();
        realKeyList.clear();
    }


    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.bt_led:
                if (GetRFIDThread.getInstance().getLockPostTag()) {
                    MUtil.show(R.string.notice_clean_data);
                } else {
                    if (openLED.getTag().equals("true")) {
                        threadAlive = true;
                        openLED.setTag("false");
                        openLED.setText(R.string.close_led);
                        ThreadUtil.getInstance().getExService().execute(new Runnable() {
                            @Override
                            public void run() {
                                while (threadAlive) {
                                    String flag = MyApp.getMyApp().getUhfMangerImpl().readTag("00000000", 0, 0, 0, "0", 0, 4, 1);
                                }
                            }
                        });
                    } else {
                        threadAlive = false;
                        openLED.setTag("true");
                        openLED.setText(R.string.open_led);
                    }
                }
                break;
            case R.id.read_RFID:
                startOrStopRFID();
                break;
            case R.id.clear_Data:
                if (GetRFIDThread.getInstance().getLockPostTag()) {
                    MUtil.show(R.string.notice_clean_data);
                } else {
                    clearData();
                }
                break;
            default:
                if (GetRFIDThread.getInstance().getLockPostTag()) {
                    MUtil.show(R.string.notice_clean_data);
                } else {
                    if (!ifNotNull()) {
                        MUtil.show(R.string.data_notnull);
                        return;
                    }
                    // true is the write button, false is the read button
                    boolean ifWrite = (v.getId() == R.id.Bt_Wr);
                    boolean status = false;
                    String result = null;
                    boolean ifChecked = CBFilterWr.isChecked();
                    int Flindex = spFilterMbWr.getSelectedItemPosition() + 1;
                    String PwdWr = EtPwdTagWr.getText().toString();
                    int Flads = Integer.valueOf(EtFilterAdsTagWr.getText().toString());
                    int Fllen = Integer.valueOf(EtFilterlenTagWr.getText().toString());
                    String Fldata = EtFilterDataTagWr.getText().toString();
                    int MbWr = spMbWr.getSelectedItemPosition();
                    int ads = Integer.valueOf(EtAdsTagWr.getText().toString());
                    int len = Integer.valueOf(EtLenTagWr.getText().toString());
                    String data = EtDataTagWr.getText().toString();

                    // Enable filtering
                    if (ifChecked) {
                        // Writing
                        if (ifWrite) {
                            status = MyApp.getMyApp().getUhfMangerImpl().writeTag(PwdWr, Flindex, Flads, Fllen, Fldata, MbWr, ads, len, data);
                        } else {
                            result = MyApp.getMyApp().getUhfMangerImpl().readTag(PwdWr, Flindex, Flads, Fllen, Fldata, MbWr, ads, len);
                        }
                    }
                    // Disable filtering
                    else {
                        if (ifWrite) {
                            if (1 == MbWr) {
                                status = MyApp.getMyApp().getUhfMangerImpl().writeDataToEpc(PwdWr, ads, len, data);
                            } else {
                                status = MyApp.getMyApp().getUhfMangerImpl().writeTag(PwdWr, 0, 0, 0, "0", MbWr, ads, len, data);
                            }
                        } else {
                            result = MyApp.getMyApp().getUhfMangerImpl().readTag(PwdWr, 0, 0, 0, "0", MbWr, ads, len);
                        }
                    }
                    String readSuccess = getString(R.string.read_success);
                    String showText = ifWrite ? (status ? getString(R.string.write_success) : getString(R.string.write_failed)) : (result == null ? getString(R.string.read_failed) : readSuccess);
                    MUtil.show(showText);
                    if (showText.equals(readSuccess)) {
                        // Shows data read successfully
                        EtDataTagWr.setText(result);
                    }
                }
                break;
        }

    }

    private boolean ifNotNull() {
        return !isEmpty(EtFilterAdsTagWr.getText()) && !isEmpty(EtFilterlenTagWr.getText()) && !isEmpty(EtFilterDataTagWr.getText()) &&
                !isEmpty(EtAdsTagWr.getText()) && !isEmpty(EtLenTagWr.getText()) && !isEmpty(EtDataTagWr.getText()) && !isEmpty(EtPwdTagWr.getText());
    }

    @Override
    public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
        String Data = mListView.getItemAtPosition(i).toString();
        MLog.e("Data = " + Data);
        EtDataTagWr.setText(Data);
    }


    private void startOrStopRFID() {

        MyApp.currentInvtDataType = 0;
        boolean flag = !GetRFIDThread.getInstance().getLockPostTag();
        if (flag) {
            if (UHFModuleType.SLR_MODULE == UHFManager.getType() && MyApp.if5100Module ){
                MyApp.getMyApp().getUhfMangerImpl().slrInventoryModeSet(0);
            }
            Boolean i = MyApp.getMyApp().getUhfMangerImpl().startInventoryTag();
        } else {
            MyApp.getMyApp().getUhfMangerImpl().stopInventory();
            //GetRFIDThread.getInstance().destoryThread();
        }
        GetRFIDThread.getInstance().setLockPostTag(flag);
        BtRead.setText(flag ? R.string.stop_rfid : R.string.read);
    }

    private void clearData() {
        dataMap.clear();
        realDataMap.clear();
        realKeyList.clear();
        mListAdapter.notifyDataSetChanged();
    }

    private Map<String, Integer> dataMap = new HashMap<>(); //数据

    @Override
    public void postResult(String[] tagData) {
        String tid = tagData[0];
        String epc = tagData[1]; 
        MLog.e("tid = " + tid + " epc = " + epc);
        //showDialog(epc);
        String filterData = epc ;
        Integer number = dataMap.get(/*epc*/filterData);
        if (number == null) {
            dataMap.put(/*epc*/filterData, 1);
            updateUI(epc, 1);
        }
    }

    @Override
    public void postInventoryRate(long rate) {

    }


    private Map<String, Integer> realDataMap = new HashMap<>();
    // realDataMap's key
    private List<String> realKeyList = new ArrayList<>();
    private void updateUI(final String epc, final int num) {
        Objects.requireNonNull(getActivity()).runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if(num == 1){
                    String filterData = epc;
                    realKeyList.add(/*epc*/filterData);
                    mListAdapter.notifyDataSetChanged();
                }
            }
        });
    }

    @Override
    public void onKeyDown(int keyCode, KeyEvent event) {

    }

    public void setListViewHeightBasedOnChildren(ListView listView) {
        ListAdapter listAdapter = listView.getAdapter();
        if (listAdapter == null) {
            return;
        }
        int totalHeight = 0;
        for (int i = 0; i < listAdapter.getCount(); i++) {
            View listItem = listAdapter.getView(i, null, listView);
            listItem.measure(0, 0);
            totalHeight += listItem.getMeasuredHeight();
        }
        ViewGroup.LayoutParams params = listView.getLayoutParams();
        params.height = totalHeight + (listView.getDividerHeight() *
                (listAdapter.getCount() - 1));
        params.height += 5;// if without this statement,the listview will be a
// little short
        listView.setLayoutParams(params);
    }


}

