package com.uhf.uhfdemo;

import android.os.Bundle;
import android.os.Handler;
import android.os.SystemClock;
//import android.support.annotation.NonNull;
//import android.support.annotation.Nullable;
import android.util.Log;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.Switch;
import android.widget.TextView;

import com.uhf.event.BackResult;
import com.uhf.event.BaseFragment;
import com.uhf.event.GetRFIDThread;
import com.uhf.util.DataAdapter;
import com.uhf.util.MLog;
import com.uhf.util.MUtil;
import com.uhf.util.ThreadUtil;
import com.uhf.base.UHFManager;
import com.uhf.base.UHFModuleType;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

import static com.uhf.uhfdemo.MyApp.ifRMModule;
import static com.uhf.uhfdemo.MyApp.ifSupportR2000Fun;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import slr.rfidlib.EPCData;

public class LeftFragment extends BaseFragment implements View.OnClickListener, BackResult, AdapterView.OnItemSelectedListener{

    private LinearLayout invDataSet;
    private TextView read_RFID;
    private TextView tagNumbers, readNumbers, useTimes, epcShow, tidShow, usrShow, rfuShow, tempShow;
    private Spinner invtDataTypeSet;
    private View epc_tid_show_divd_Line, epc_usr_show_divd_Line, epc_rfu_show_divd_Line;
    private String tagNumber, readNumber, takeTime;

    private long startTime, usTim, pauseTime;
    private DataAdapter mListAdapter;


    private Handler handler = new Handler();

    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        tagNumber = getString(R.string.tag_number) + ":";
        readNumber = getString(R.string.read_number) + ":";
        takeTime = getString(R.string.user_time) + ":";
        return inflater.inflate(R.layout.fragment_left, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        initView(view);
    }

    private void initView(final View v) {
        read_RFID = v.findViewById(R.id.read_RFID);
        // Clear data
        v.findViewById(R.id.clear_Data).setOnClickListener(this);
        ListView specific_Msg = v.findViewById(R.id.specific_Msg);

        tagNumbers = v.findViewById(R.id.tagNumbers);
        readNumbers = v.findViewById(R.id.readNumbers);
        useTimes = v.findViewById(R.id.useTimes);

        epcShow = v.findViewById(R.id.epcShow);
        tidShow = v.findViewById(R.id.tidShow);
        usrShow = v.findViewById(R.id.usrShow);
        rfuShow = v.findViewById(R.id.rfuShow);
        tempShow = v.findViewById(R.id.temp);
        epc_tid_show_divd_Line = v.findViewById(R.id.epc_tid_show_divd_Line);
        epc_usr_show_divd_Line = v.findViewById(R.id.epc_usr_show_divd_Line);
        epc_rfu_show_divd_Line = v.findViewById(R.id.epc_rfu_show_divd_Line);
        invDataSet = v.findViewById(R.id.invDataSet);
        invtDataTypeSet = v.findViewById(R.id.invModSet);
        refreshUI();
        invtDataTypeSet.setOnItemSelectedListener(this);
        if (MyApp.currentInvtDataType > -1) {
            SystemClock.sleep(1000);
            refreshTagDataTypeShow(MyApp.currentInvtDataType);
            invtDataTypeSet.setSelection(MyApp.currentInvtDataType);
        }

        read_RFID.setOnClickListener(this);
        read_RFID.setText(GetRFIDThread.getInstance().isIfPostMsg() ? R.string.stop_rfid : R.string.read_rfid);

        mListAdapter = new DataAdapter(getActivity(), realDataMap, realKeyList, tidList, usrList, rfuList);
        specific_Msg.setAdapter(mListAdapter);
        GetRFIDThread.getInstance().setBackResult(this);
        //MyApp.getMyApp().getUhfMangerImpl().slrSetEPCData(this);
    }

    @Override
    public void refreshUI() {
        super.refreshUI();
        // Determining if it is a UM7 module , Or is it a 5100 module
        if (MyApp.getMyApp().getUhfMangerImpl().ifJ06() || !ifSupportR2000Fun || MyApp.if5100Module) {
            invDataSet.setVisibility(View.GONE);
        }else if (ifRMModule) {
            invDataSet.setVisibility(View.GONE);
        }else if (UHFModuleType.SLR_MODULE == UHFManager.getType()) {
            invtDataTypeSet.setAdapter(new ArrayAdapter<>(Objects.requireNonNull(getActivity()),
                    android.R.layout.simple_spinner_dropdown_item, getResources().getStringArray(R.array.readTagType_7100)));
        }else {
            invDataSet.setVisibility(View.VISIBLE);
        }

    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.read_RFID:
                startOrStopRFID();
                break;
            // Clear data
            case R.id.clear_Data:
                if (GetRFIDThread.getInstance().isIfPostMsg()) {
                    MUtil.show(R.string.notice_clean_data);
                } else {
                    clearData();
                }
                break;
            default:
                break;
        }
    }

    private void clearData() {
        dataMap.clear();
        realDataMap.clear();
        realKeyList.clear();
        tidList.clear();
        usrList.clear();
        rfuList.clear();
        usTim = pauseTime = 0;
        useTimes.setText(takeTime);
        tagNumbers.setText(tagNumber);
        readNumbers.setText(readNumber);
        mListAdapter.notifyDataSetChanged();
    }

    // Start or Stop RFID
    Runnable task;
    boolean ifOpenFan = false;
    public void startOrStopRFID() {
        boolean flag = !GetRFIDThread.getInstance().isIfPostMsg();
        invtDataTypeSet.setEnabled(!flag);
        if (flag) {
            if (UHFModuleType.SLR_MODULE == UHFManager.getType() && MyApp.if5100Module){
                MyApp.getMyApp().getUhfMangerImpl().slrInventoryModeSet(0);
            }
//            if ((UHFModuleType.SLR_MODULE == UHFManager.getType()) && MyApp.if7100Module) {
//                MyApp.getMyApp().getUhfMangerImpl().slrInventoryModeSet(4);
//            }
            Boolean i = MyApp.getMyApp().getUhfMangerImpl().startInventoryTag();

            long tempTime = pauseTime;
            startTime = System.currentTimeMillis() - tempTime;
            ifSoundThreadAlive = true;
            playSound();
//            if (ifRMModule && UHFModuleType.RM_MODULE == UHFManager.getType()) {
//                handler.postDelayed(task = new Runnable() {
//                    @Override
//                    public void run() {
//                        if (Temp > 40) {
//                            if (!ifOpenFan) {
//                                MyApp.getMyApp().getUhfMangerImpl().openFan();
//                                ifOpenFan = true;
//                            }
//                        }else if (Temp < 40) {
//                            if (ifOpenFan) {
//                                MyApp.getMyApp().getUhfMangerImpl().closeFan();
//                                ifOpenFan = false;
//                            }
//                        }
//                        handler.postDelayed(this,5000);
//                    }
//                },5000);
//            }
        } else {
            ifHaveTag = false;
            ifSoundThreadAlive = false;
            Boolean i = MyApp.getMyApp().getUhfMangerImpl().stopInventory();
//            if (ifRMModule && UHFModuleType.RM_MODULE == UHFManager.getType()) {
//                if (task !=null) {
//                    if (ifOpenFan) {
//                        MyApp.getMyApp().getUhfMangerImpl().closeFan();
//                        ifOpenFan = false;
//                    }
//                    handler.removeCallbacks(task);
//                }
//            }
        }
        GetRFIDThread.getInstance().setIfPostMsg(flag);
        read_RFID.setText(flag ? R.string.stop_rfid : R.string.read_rfid);
    }


    //The label's info what has been identified
    private Map<String, Integer> dataMap = new HashMap<>();

    private long postDataTime = 0;

    int Temp = 0;
    @Override
    public void postResult(String[] tagData) {
        //++rNumber;
        //Log.e("TAG", "postResult: "+ Arrays.toString(tagData));
        postDataTime = SystemClock.elapsedRealtime();
        ifHaveTag = true;
        String tid = tagData[0];
        String usr = tagData[0];
        String rfu = tagData[0];
//        if (ifRMModule)
//            Temp = Integer.parseInt(tagData[2]);
        if(MyApp.currentInvtDataType == 3){
            usr = tagData[0];
        } else if(MyApp.currentInvtDataType == 4) {
            tid = tagData[0].substring(0,24);
            usr = tagData[0].substring(24);
        }else if (MyApp.currentInvtDataType == 5) {
            tid = tagData[0].substring(0,24);
            rfu = tagData[0].substring(24,tagData[0].length()-2);
        } else if (MyApp.currentInvtDataType == 6){
            rfu =tagData[0];
        }
        String epc = tagData[1];
        //MLog.e("tid = " + tid + " epc = " + epc +" usr = " + usr + " rfu = " + rfu);
        //showDialog(epc);
        String filterData = MyApp.currentInvtDataType == 1 || MyApp.currentInvtDataType == 2 || MyApp.currentInvtDataType == 4 || MyApp.currentInvtDataType == 5 ? tid : epc;

        // If it already exists, get the number
        Integer number = dataMap.get(/*epc*/filterData);
        if (number == null) {
            dataMap.put(/*epc*/filterData, 1);
            updateUI(epc, tid, usr, rfu, 1);
        } else {
            int newNB = number + 1;
            dataMap.put(/*epc*/filterData, ++newNB);
            updateUI(epc, tid, usr, rfu, newNB);
        }
    }

    @Override
    public void postInventoryRate(final long rate) {
        getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                // tags per second
                readNumbers.setText(rate + readNumber);
            }
        });
    }

    @Override
    public void onKeyDown(int keyCode, KeyEvent event) {
        MLog.e("keyCode =" + keyCode);
        //The trigger button is pressed, and the default value is F8,F4,BTN4
        if (keyCode == KeyEvent.KEYCODE_F8 || keyCode == KeyEvent.KEYCODE_F4 || keyCode == KeyEvent.KEYCODE_BUTTON_4 || keyCode == KeyEvent.KEYCODE_PROG_RED) {
            startOrStopRFID();
        }
    }

    private Map<String, Integer> realDataMap = new HashMap<>();
    // realDataMap's key
    private List<String> realKeyList = new ArrayList<>();
    //tid info
    private List<String> tidList = new ArrayList<>();
    //usr info
    private List<String> usrList = new ArrayList<>();
    //rfu info
    private List<String> rfuList = new ArrayList<>();

    private void updateUI(final String epc, final String tid, final String usr, final String rfu, final int readNumberss) {
        Objects.requireNonNull(getActivity()).runOnUiThread(new Runnable() {
            @Override
            public void run() {
                String filterData = MyApp.currentInvtDataType == 1 || MyApp.currentInvtDataType == 2 || MyApp.currentInvtDataType == 4 || MyApp.currentInvtDataType == 5 ? tid : epc;
                if (readNumberss > 1) {
                    //Modified quantity
                    realDataMap.put(/*epc*/filterData, readNumberss);
                } else {
                    realDataMap.put(/*epc*/filterData, 1);
                    realKeyList.add(/*epc*/filterData);
                    tidList.add(MyApp.currentInvtDataType <= 0 ? tid : epc);
                    usrList.add(usr);
                    rfuList.add(rfu);
                    MLog.e("tid = " + tid + " epc = " + epc +" usr = " + usr + " rfu = " + rfu);

                }
                long endTime = System.currentTimeMillis();
                //Acquisition time from start to end of inventorying tag
                pauseTime = usTim = endTime - startTime;
                //Time spent
                useTimes.setText(takeTime + usTim);
                //Number of tags
                tagNumbers.setText(tagNumber + realDataMap.size());
                mListAdapter.notifyDataSetChanged();
                long realUseTime = System.currentTimeMillis() - lastTime;
            /*    if (MyApp.ifOpenSound && realUseTime > 60) {
                    MyApp.getMyApp().playSound();
                    lastTime = endTime;
                }*/
//                tempShow.setText(Temp + "℃");
            }
        });
    }

    private boolean ifSoundThreadAlive = true;
    private boolean ifHaveTag = false;
    private long lastTime;

    private void playSound() {
        ThreadUtil.getInstance().getExService().execute(new Runnable() {
            @Override
            public void run() {
                while (MyApp.ifOpenSound && ifSoundThreadAlive) {
                    if (ifHaveTag) {
                        //Pause playing sound without data for more than 1 s
                        if (lastTime != 0 && lastTime - postDataTime > 1000) {
                            ifHaveTag = false;
                            continue;
                        }
                        MyApp.getMyApp().playSound();
                        SystemClock.sleep(600);
                        lastTime = SystemClock.elapsedRealtime();
                    }
                }
            }
        });
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        ifHaveTag = false;
        ifSoundThreadAlive = false;
    }

    private void refreshTagDataTypeShow(int position) {
        clearData();
        epcShow.setVisibility(position == 1 ? View.GONE : View.VISIBLE);
        tidShow.setVisibility(position == 0 || position == 3 || position == 6 ? View.GONE : View.VISIBLE);
        usrShow.setVisibility(position == 3 || position == 4 ? View.VISIBLE : View.GONE);
        rfuShow.setVisibility(position == 5 || position == 6 ? View.VISIBLE : View.GONE);
        epc_tid_show_divd_Line.setVisibility(position == 0 || position == 3 || position == 6 ? View.GONE : View.VISIBLE);
        epc_usr_show_divd_Line.setVisibility(position == 3 || position == 4 ? View.VISIBLE : View.GONE);
        epc_rfu_show_divd_Line.setVisibility(position == 5 || position == 6 ? View.VISIBLE : View.GONE);
    }

    @Override
    public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
        MyApp.currentInvtDataType = position;
        mListAdapter.setMode(position);
        refreshTagDataTypeShow(position);
        //OnlyTID+EPC,and EPC MODE
        switch(position) {
            case 0:
                position =0;
                break;
            case 1:
                position =1;
                break;
            case 2:
                position =1;
                break;
            case 3:
                position =2;
                break;
            case 4:
                position =3;
                break;
            case 5:
                position =4;
                break;
            case 6:
                position =5;
                break;
        }
        //position = Math.min(position, 1);
        if (position == 2 || position == 3) {
            boolean i = MyApp.getMyApp().getUhfMangerImpl().readTagModeSet(position, 0, 24, 0);
            MLog.e("position= " + position + " readTagModeSet = " + i);
        } else {
            //SystemClock.sleep(500);
            boolean i =MyApp.getMyApp().getUhfMangerImpl().readTagModeSet(position, 0, 0, 0);
            MLog.e("position= " + position + " readTagModeSet = " + i);
        }

    }

    @Override
    public void onNothingSelected(AdapterView<?> parent) {

    }
//    @Override
//    public void getEpcData(String[] tagData) {
//        postDataTime = SystemClock.elapsedRealtime();
//        ifHaveTag = true;
//        //获取TID
//        // get TID
//        String tid = tagData[0];
//        String usr = tagData[0];
//        String rfu = tagData[0];
//        //拿到EPC
//        // get EPC
//        if(MyApp.currentInvtDataType == 3){
//            usr = tagData[0];
//        } else if(MyApp.currentInvtDataType == 4) {
//            tid = tagData[0].substring(0,24);
//            usr = tagData[0].substring(24);
//        }else if (MyApp.currentInvtDataType == 5) {
//            tid = tagData[0].substring(0,24);
//            rfu = tagData[0].substring(24,tagData[0].length()-2);
//        } else if (MyApp.currentInvtDataType == 6){
//            rfu =tagData[0];
//        }
//        String epc = tagData[1];
//        MLog.e("tid = " + tid + " epc = " + epc +" usr = " + usr + " rfu = " + rfu);
//        //showDialog(epc);
//        String filterData = MyApp.currentInvtDataType == 1 || MyApp.currentInvtDataType == 2 || MyApp.currentInvtDataType == 4 || MyApp.currentInvtDataType == 5 ? tid : epc;
//
//        // If it already exists, get the number
//        Integer number = dataMap.get(/*epc*/filterData);
//        if (number == null) {
//            dataMap.put(/*epc*/filterData, 1);
//            updateUI(epc, tid, usr, rfu, 1);
//        } else {
//            int newNB = number + 1;
//            dataMap.put(/*epc*/filterData, ++newNB);
//            updateUI(epc, tid, usr, rfu, newNB);
//        }
//    }
}
